﻿<%@ Page Language="C#" AutoEventWireup="true"  CodeFile="Default.aspx.cs" Inherits="_Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>LDAP Example </title>
</head>
<script type="text/javascript">  
 
function OnCheckBoxCheckChanged(evt)
{   
    var src = window.event != window.undefined ? window.event.srcElement : evt.target;   
    var isChkBoxClick = (src.tagName.toLowerCase() == "input" && src.type == "checkbox");   
    if (isChkBoxClick) 
    {             
        var parentTable = GetParentByTagName("table", src);        
        var nxtSibling = parentTable.nextSibling;   
        if (nxtSibling && nxtSibling.nodeType == 1)
        //check if nxtsibling is not null & is an element node  
          {                
               if (nxtSibling.tagName.toLowerCase() == "div")
                {             
                       //check or uncheck children at all levels    
                       CheckUncheckChildren(parentTable.nextSibling, src.checked);  
      
                 }    
           }   
          CheckUncheckParents(src, src.checked);    
    }          
  } 
  
       
     function CheckUncheckChildren(childContainer, check)
      {        
            var childChkBoxes = childContainer.getElementsByTagName("input");     
            var childChkBoxCount = childChkBoxes.length;          
            for (var i = 0; i < childChkBoxCount; i++)
                {                
                    childChkBoxes[i].checked = check;           
                }            
        }
        
     function CheckUncheckParents(srcChild, check)
         {
         var parentDiv = GetParentByTagName("div", srcChild);     
         var parentNodeTable = parentDiv.previousSibling;    
         if (parentNodeTable)
            {                     
                var checkUncheckSwitch;        
                if (check) 
                  { 
                        var isAllSiblingsChecked = AreAllSiblingsChecked(srcChild);  
                         if (isAllSiblingsChecked)                     
                              checkUncheckSwitch = true;                                   
                          else      
                              return; 
                   }      
                  else 
                   {  
                        checkUncheckSwitch = false;   
                    }      
                var inpElemsInParentTable = parentNodeTable.getElementsByTagName("input"); 
                if (inpElemsInParentTable.length > 0)
                 {
                    var parentNodeChkBox = inpElemsInParentTable[0];
                    parentNodeChkBox.checked = checkUncheckSwitch;                         
                    CheckUncheckParents(parentNodeChkBox, checkUncheckSwitch);   
                 }         
            }           
        }
        
         
         function AreAllSiblingsChecked(chkBox)
         {               
            var parentDiv = GetParentByTagName("div", chkBox);  
            var childCount = parentDiv.childNodes.length;       
            for (var i = 0; i < childCount; i++) 
            {  
                if (parentDiv.childNodes[i].nodeType == 1) 
                 {
                    if (parentDiv.childNodes[i].tagName.toLowerCase() == "table") 
                     {          
                        var prevChkBox = parentDiv.childNodes[i].getElementsByTagName("input")[0];                                                
                        if (!prevChkBox.checked) 
                        {  
                            return false; 
                        }   
                      }
                   } 
                   
                }              
             return true; 
           }               
                 
    function GetParentByTagName(parentTagName, childElementObj)
     {
        var parent = childElementObj.parentNode; 
        while (parent.tagName.toLowerCase() != parentTagName.toLowerCase())
         { 
            parent = parent.parentNode; 
          }
          return parent;
      }   
</script>
<body>
    <form id="form1" runat="server">
    <div>
    <table cellpadding ="2" cellspacing="2" border = "0">
        <tr>
            <td>
                Domain Path :
            </td>
            <td>
                <asp:TextBox ID="txtDomainName" runat ="server"  Text = "LDAP://DomainName"></asp:TextBox>
            </td>
        </tr>
        <tr>
            <td>
                User Name :
            </td>
            <td>
                <asp:TextBox ID="txtUserName" runat ="server"></asp:TextBox>
            </td>
        </tr>
        <tr>
            <td>
                Password :
            </td>
            <td>
                <asp:TextBox ID="txtPassword" runat ="server"></asp:TextBox>
            </td>
            
        </tr>
        <tr>
            <td colspan ="2">
                <asp:Button ID="btnLoadDomain" runat="Server" text ="LoadDomain" OnClick="btnLoadDomain_Click" />
            </td>
            
        </tr>
    </table> 
    <asp:TreeView ID="tvDomainController" ImageSet="msdn" onclick="Javascript: OnCheckBoxCheckChanged(event);"
                OnTreeNodePopulate="PopulateNode" ShowCheckBoxes="All" ShowLines="false" Width="250"
                ExpandDepth="5" runat="Server">
            </asp:TreeView>
            <asp:Label runat ="server" ID="lblStatus" ForeColor ="red"></asp:Label>
            
            <br />
            <asp:Button ID="BtnLoad" runat ="Server" Text = "Load Selected Values" OnClick="BtnLoad_Click" />
            <asp:DataGrid ID="dgSelectedValues" runat ="Server"  AutoGenerateColumns = "true" >
            </asp:DataGrid><br />
            
            -------------------------------------------<br />
            
            <asp:TextBox ID="txtPath" runat="Server" ></asp:TextBox>
            <asp:Button id="Submit"
        Text="Find Node"
        
        runat="server" OnClick="Submit_Click"/>
        (type valuepath in textBox)<br />
        <asp:Label ID="Message" runat="server" ForeColor = "red"></asp:Label>
        <asp:HiddenField ID="hdnAdPath" runat="Server" Value="" />
        <asp:HiddenField ID="hdnStatus" runat="Server" Value="" />
        <asp:HiddenField ID="hdnUserName" runat="Server" Value="" />
        <asp:HiddenField ID="hdnUserPassword" runat="Server" Value="" />
    </div>
    </form>
</body>
</html>
